<?php
// https://datatables.net/forums/discussion/comment/107184/#Comment_107184
include("openssl_enc_dec.php");
if (isset($_REQUEST["cfg"])) {
    $sql_details = unserialize(urldecode(encrypt_decrypt('decrypt', $_REQUEST['cfg'])));
}
include("../dt/Editor/lib/DataTables.php");

date_default_timezone_set('Europe/Bratislava');

use
	DataTables\Editor,
	DataTables\Editor\Field,
	DataTables\Editor\Format,
	DataTables\Editor\Mjoin,
	DataTables\Editor\Options,
	DataTables\Editor\Upload,
	DataTables\Editor\Validate,
	DataTables\Editor\ValidateOptions;

$first_name = (isset($_GET['first_name']) ? $_GET['first_name'] : '');
$last_name = (isset($_GET['last_name']) ? $_GET['last_name'] : '');
$vymazany = (isset($_POST['vymazany']) && is_numeric($_POST['vymazany'])) ? $_POST['vymazany'] + 0 : 0;
$vyradeny = (isset($_POST['vyradeny']) && is_numeric($_POST['vyradeny'])) ? $_POST['vyradeny'] + 0 : 0;
$nenajdeny = (isset($_POST['nenajdeny']) && is_numeric($_POST['nenajdeny'])) ? $_POST['nenajdeny'] + 0 : 0;
$lang = (isset($_REQUEST['lang']) ? $_REQUEST['lang'] : 'sk'); // jazyk

// file_put_contents('log', print_r($_POST, true)."\n", FILE_APPEND);
function validateDate($date, $format = 'd.m.Y') {
    $d = DateTime::createFromFormat($format, $date);
    return $d && $d->format($format) == $date;
}

if ( $_SERVER["REQUEST_METHOD"] == "POST" ) {

    $doc_path = "";
    $res = $db->raw()
        //->bind(':pin', $pin)
        ->exec('select doc_path from nastavenia limit 1');
    $row = $res->fetch(PDO::FETCH_ASSOC);
    if ($row) {
        $doc_path = $row['doc_path'];
        if ($doc_path != "")
            $doc_path = $doc_path . '/';
    }

    // Web and thumbs paths to file
    $webPath = "/uploads/$doc_path";
    //$webPathThumbs1 = '/upload/thumbnails/';
    //$webPathThumbs2 = '/upload/thumbnails2/';
       
    // System paths
    $sysPath = $_SERVER['DOCUMENT_ROOT'] . $webPath;
    //$sysPathThumbs1 = $_SERVER['DOCUMENT_ROOT'] . $webPathThumbs1;
    //$sysPathThumbs2 = $_SERVER['DOCUMENT_ROOT'] . $webPathThumbs2;
         
    // Create an array to be used in function
    $varArray = [
        "webPath" => $webPath,
        "sysPath" => $sysPath
        //"webPathTumbs1" =>  $webPathThumbs1,
        //"sysPathThumbs1" => $sysPathThumbs1,
        //"webPathThumbs2" => $webPathThumbs2,
        //"sysPathThumbs2" => $sysPathThumbs2
    ];
}

$editor = Editor::inst($db, 'majetok')
//->debug(true)
->fields(
	Field::inst('majetok.id')->set(false),
    Field::inst('majetok.kod')
	    ->validator(Validate::notEmpty(ValidateOptions::inst()
            ->message( 'Povinný údaj' )
	    ))
	    ->validator(Validate::unique(ValidateOptions::inst()
	        ->message(($lang == 'sk') ? 'Kód už existuje' : 'Kód již existuje')
	    )),
    Field::inst('majetok.nazov'),
    Field::inst('majetok.druh')
	    ->options(Options::inst()
	        ->add('-', '')
	        ->table('druhy')
	        ->value('kod')
	        ->label('nazov')
	        ->order('nazov')
        ),
    Field::inst('druhy.nazov')->set(false),
    Field::inst('majetok.kod_os')
	    ->options(Options::inst()
	        ->add('-', '')
	        ->table('org_str')
	        ->value('kod')
	        ->label('nazov')
	        ->order('nazov')
        ),
    Field::inst('org_str.nazov')->set(false),
    Field::inst('majetok.kod_eo')
        ->options(Options::inst()
	        ->add('-', '')
	        ->table('ekon_obj')
	        ->value('kod')
	        ->label('nazov')
	        ->order('nazov')
        ),
    Field::inst('ekon_obj.nazov')->set(false),
    Field::inst('majetok.kod_lok')
	    ->options(Options::inst()
	        ->add('-', '')
	        ->table('lokacie')
	        ->value('kod')
	        ->label('nazov')
	        ->order('nazov')
        ),
    Field::inst('lokacie.nazov')->set(false),
    Field::inst('majetok.kod_osoby')
	    ->options(Options::inst()
	        ->add('-', '')
	        ->table('osoby')
	        ->value('kod')
	        ->label('meno')
	        ->order('meno')
	    ),
    Field::inst('osoby.meno')->set(false),
    Field::inst('majetok.vp1'),
    Field::inst('majetok.vp2'),
    Field::inst('majetok.vp3'),
    Field::inst('majetok.mnozstvo')
	    -> getFormatter(function ($val) {
	        return str_replace('.', ',', $val);
	    })
	    -> setFormatter(function ($val) {
	        return str_replace(',', '.', $val);
	    })
        ->validator(Validate::numeric(',', ValidateOptions::inst()
            ->message('Neplatná číselná hodnota')
	    )),
    Field::inst('majetok.datum_zarad')
	    ->validator('Validate::dateFormat', array(
	        "empty" => true,
	        "format" => "d.m.Y",
	        "message" => ($lang == 'sk') ? "Zadajte dátum v tvare dd.mm.rrrr" : "Zadejte datum ve tvaru dd.mm.rrrr"
	    ))
	    ->setFormatter(function ($val) {
	        if ($val != "") {
	            $date = new DateTime($val);
	            return date_format($date, 'Y-m-d');
	        } else {
	            return "NULL";
	        }
	    })
	    ->getFormatter(function ($val) {
	        if ($val != "0000-00-00") {
	            $date = new DateTime($val);
	            return date_format($date, 'd.m.Y');
	        } else {
	            return null;
	        }
	    }),
    Field::inst('majetok.cena')
	    -> getFormatter(function ($val) {
	        return str_replace('.', ',', $val);
	    })
	    -> setFormatter(function ($val) {
	        return str_replace(',', '.', $val);
	    })
	    ->validator(Validate::numeric(',', ValidateOptions::inst()
	        ->message('Neplatná číselná hodnota')
        )),
    Field::inst('majetok.vyr_cislo'),
    Field::inst('majetok.datum_inv')
        ->validator('Validate::dateFormat', array(
            "empty" => true,
            "format" => "d.m.Y",
            "message" => ($lang == 'sk') ? "Zadajte dátum v tvare dd.mm.rrrr" : "Zadejte datum ve tvaru dd.mm.rrrr"
        ))
        ->setFormatter(function ($val) {
            if ($val != "") {
                $date = new DateTime($val);
                return date_format($date, 'Y-m-d');
            } else {
                return "NULL";
            }
        })
        ->getFormatter(function ($val) {
            if ($val != "0000-00-00") {
                $date = new DateTime($val);
                return date_format($date, 'd.m.Y');
            } else {
                return null;
            }
        }),
    Field::inst('majetok.poznamka_inv'),
    Field::inst('majetok.datum_vymaz')
        ->validator('Validate::dateFormat', array(
            "empty" => true,
            "format" => "d.m.Y",
            "message" => ($lang == 'sk') ? "Zadajte dátum v tvare dd.mm.rrrr" : "Zadejte datum ve tvaru dd.mm.rrrr"
        ))
        ->setFormatter(function ($val) {
            if ($val != "") {
                $date = new DateTime($val);
                return date_format($date, 'Y-m-d');
            } else {
                return "NULL";
            }
        })
        ->getFormatter(function ($val) {
            if ($val != "0000-00-00") {
                $date = new DateTime($val);
                return date_format($date, 'd.m.Y');
            } else {
                return null;
            }
        }),
    Field::inst('majetok.vymazal'),
    Field::inst('majetok.datum_vyrad')
        ->set(false)
        ->getFormatter(function ($val) {
            if ($val != "") {
                $date = new DateTime($val);
                return date_format($date, 'd.m.Y');
            } else {
                return null;
            }
        })
    )
    ->leftJoin('druhy', 'druhy.kod', '=', 'majetok.druh')
    ->leftJoin('org_str', 'org_str.kod', '=', 'majetok.kod_os')
	->leftJoin('ekon_obj', 'ekon_obj.kod', '=', 'majetok.kod_eo')
	->leftJoin('lokacie', 'lokacie.kod', '=', 'majetok.kod_lok')
	->leftJoin('osoby', 'osoby.kod', '=', 'majetok.kod_osoby')
    ->join(
	    Mjoin::inst('files')
	    ->link('majetok.id', 'majetok_file.majetok_id')
	    ->link('files.id', 'majetok_file.file_id')
	    ->fields(
	        Field::inst('id')
                //->set(false)
	            ->upload(
                    /*
                    Upload::inst($_SERVER['DOCUMENT_ROOT']."/uploads/__NAME__")
                    ->db('files', 'id', array(
                        'web_path'		=> Upload::DB_WEB_PATH,
                        'system_path'	=> Upload::DB_SYSTEM_PATH,
                        'typ'	=> 0,
                        )
                    )
                    */
                    
                    // Custom upload actions. start
                    Upload::inst(function($file, $id) use ($varArray, $db) {
                        move_uploaded_file($file['tmp_name'] , $varArray["sysPath"] . $file['name']);

                        //file_put_contents('log', "file: ".print_r($file, true) . "\n", FILE_APPEND);
                        //file_put_contents('log', "id: ".print_r($id, true) . "\n", FILE_APPEND);
                        //ile_put_contents('log', "varArray: ".print_r($varArray, true) . "\n", FILE_APPEND);

                        //make_thumb($varArray["sysPath"] .$id. '.jpg', $varArray["sysPathThumbs1"].$id. '.jpg', 480);
                        //make_thumb($varArray["sysPath"] .$id. '.jpg', $varArray["sysPathThumbs2"].$id. '.jpg', 120);
                        
                        $db->update('files', // Database table to update
                          [
                           "web_path" => $varArray["webPath"] . $file['name'],
                           "system_path" => $varArray["sysPath"] . $file['name']
                           //"web_path_thumb1" => $varArray["webPathTumbs1"] .$id. '.jpg',
                           //"system_path_thumb1" => $varArray["sysPathThumbs1"]  .$id. '.jpg', 
                           //"web_path_thumb2" => $varArray["webPathThumbs2"] .$id. '.jpg',
                           //"system_path_thumb2" => $varArray["sysPathThumbs2"]  .$id. '.jpg', 
                          ],
                          [ "id" => $id ]
                        );
                        return $id;
                    })
                    ->db('files', 'id', array(
                        'web_path'		=> '',
                        'system_path'	=> '',
                        'typ'	=> 0
                        )
                    )
                

                ),
	        Field::inst('web_path'),
	        Field::inst('system_path'),
	        Field::inst('typ')
	    )
    )
	->where('majetok.novy', 0)
	->on('preRemove', function ($editor, $id, $values) use ($db, $first_name, $last_name) {
	       if ($values['majetok']['datum_vymaz'] == '') {
    		    $meno = $first_name . ' ' . $last_name;
    		    $sql = "update majetok set datum_vymaz=curdate(), vymazal='$meno' where (id=$id) and (datum_vymaz='0000-00-00')";
    		    $db->sql($sql);
    		    return false; // dolezite, aby sa zaznam nevymazal
		    } else {
		        return true; // vymaz zaznam
		    }
	});


if ($vymazany == 1) {
    $editor->where('majetok.datum_vymaz', '0000-00-00', '<>');
} else {
    $editor->where('majetok.datum_vymaz', '0000-00-00', '=');
}

if ($vyradeny == 1) {
    $editor->where('majetok.datum_vyrad', '', '<>');
}

if ($nenajdeny == 1) {
    $editor->where(function ($q) {
        $q->where('majetok.kod', '(select kod from inventura)', 'not in', false);
    });
}

if (!isset($_POST['action'])) {
    // filtrovanie < > =
    foreach ($_POST["columns"] as &$column) {
        if ($column["search"]["value"] != "") {
            $value = $column["search"]["value"];
            $operator = "";
            if (($value[0] == ">") || ($value[0] == "<") || ($value[0] == "=")) {
                $operator = $value[0];
            }
            if ((substr($value, 0, 2) == ">=") || (substr($value, 0, 2) == "<=") || (substr($value, 0, 2) == "<>")) {
                $operator = substr($value, 0, 2);
            }
            $value = str_replace($operator, "", $value);
            $value = stripslashes($value);  // zmaz znak \
            
            if (strpos($column["data"], 'datum') !== false) {
                // je to datum, uprav vyraz do spravneho formatu
                // konvertuj filtracny vyraz z DD.MM.YYYY na YYYY-MM-DD
                $d = DateTime::createFromFormat('d.m.Y', $value);
                if ($d && $d->format('d.m.Y') == $value) { // test ci je to ozaj datum
                    $value = $d->format('Y-m-d'); // konverzia do YYYY-MM-DD
                } else {
                    if (($value == '00.00.0000') || ($value == '00')) {
                        $value = "0000-00-00";
                    } else {
                        $value = "";
                    }
                }
                if (($value != "") && ($operator == "")) {
                    $operator = "=";
                }
            }
            
            if ($operator != "") {
                if ($value != "") {
                    $editor->where($column["data"], $value, $operator, false);
                }
                // dalej nefiltruj v metode process
                $column["search"]["value"] = "";
            }
        }
    }
}

$out = $editor
->process($_POST)
->data();
//file_put_contents('log', "out: ".print_r($out, true) . "\n", FILE_APPEND);
echo json_encode($out);
    
?>